//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "SinglePlay.h"
#include "math.h"
#include "Usage_SinglePlay.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TForm2 *Form2;
//---------------------------------------------------------------------------
__fastcall TForm2::TForm2(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm2::Button2Click(TObject *Sender)
{
        Form2->Close();        
}
//---------------------------------------------------------------------------

// Expected value for victory of 1
float Elo_P(float Elo1, float Elo2){
        float Elo_Pi;
	Elo_Pi = 1 / (1 + exp(((Elo2 - Elo1) / 400) * log(10)));
        return Elo_Pi;
}

// Calculate Single Play Result
void __fastcall TForm2::Button1Click(TObject *Sender)
{
        AnsiString str_tmp1, str_tmp2;
        float Elo1, Elo2, pwin, plose, premis, EW, remisweight;
        remisweight = 0.4;
        str_tmp1 = Edit3->Text; str_tmp2 = Edit4->Text;
        Elo1 = StrToFloat(str_tmp1); Elo2 = StrToFloat(str_tmp2);

        if (CheckBox1->Checked == true) Elo1 = Elo1 + 100.0;
        if (CheckBox2->Checked == true) Elo2 = Elo2 + 100.0;

        EW = Elo_P(Elo1, Elo2);
        // KO Round: Elo result
        if (CheckBox3->Checked == true){
                Edit5->Text = FormatFloat("0.00", EW * 100);
                Edit6->Text = FormatFloat("0.00", (1.0 - EW) * 100);
                Edit7->Text = "0.00";
                pwin = EW; plose = 1- EW; premis = 0;
        }
        // With Remis: Superposition of maximum remis and KO scenario
        if (CheckBox3->Checked == false){
                if (EW >= 0.5){
                        plose = 0;
                        premis = 2.0 - 2.0 * EW;
                        pwin = 1.0 - premis;
                }
                else{
                        pwin = 0;
                        premis = 2.0 * EW;
                        plose = 1.0 - premis;
                }
                pwin = remisweight * pwin + (1 - remisweight) * EW;
                plose = remisweight * plose + (1 - remisweight) * (1 - EW);
                premis = remisweight * premis;

                Edit5->Text = FormatFloat("0.00", pwin * 100);
                Edit6->Text = FormatFloat("0.00", plose * 100);
                Edit7->Text = FormatFloat("0.00", premis * 100);
        }

        //Diagram
        Chartfx3->OpenDataEx(COD_VALUES, 3, 1);
        Chartfx3->ThisSerie = 0; Chartfx3->Value[0] = 100.0 * plose;
        Chartfx3->ThisSerie = 1; Chartfx3->Value[0] = 100.0 * premis;
        Chartfx3->ThisSerie = 2; Chartfx3->Value[0] = 100.0 * pwin;
        Chartfx3->CloseData(COD_VALUES);
}
//---------------------------------------------------------------------------

void __fastcall TForm2::UsageClick(TObject *Sender)
{
        Form15->ShowModal();        
}
//---------------------------------------------------------------------------

